#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "symbol.h"
#include "dislib.h"
#include "loader.h"
#include "version.h"


    /* The Main Program */
int main(int argc,char **argv) {

    int text_size,bss_size,text_offset,bss_offset;
    char *input_filename;
    FILE *output_file;
    unsigned char *text_data;
    


       /* parse command line args */
    if (argc<2) {
       fprintf(stderr,"\nUsage : %s filename\n\n",argv[0]);
    }

    input_filename=argv[1];

    open_object(input_filename);
   
    if (object.type!=OBJECT_NEW) {   
       fprintf(stderr,"ERROR!  Old object type cannot be stripped!\n");
       exit(1);
    }

    text_size=object.text_size;
    bss_size=object.bss_size;
    text_offset=object.text_offset;
    bss_offset=object.bss_offset;

    text_data=malloc(text_size);
    fseek(object.file,object.header_size,SEEK_SET);
    fread(text_data,sizeof(unsigned char),text_size,object.file);
   
    close_object();

    /* by default, over-write existing file */
    output_file=fopen(input_filename,"w");
    if (output_file==NULL) {
       fprintf(stderr,"Error over-writing %s\n",input_filename);
       exit(1);
    }
   
    /* write out a header w/o a symbol table */
    write_header(output_file,
                 0,0,
		 text_size,text_offset,
		 bss_size,bss_offset);
    fwrite(text_data,sizeof(unsigned char),text_size,output_file);


    fclose(output_file);
   
    return 0;  
}
