#include <stdio.h>
#include <stdlib.h>
#include <unistd.h> /* write() */
#include <string.h> /* strlen() */

unsigned short r[8];
unsigned short mem[65536];

#define LOGO 8192
#define LOGO_SIZE 283

#define HELLO 9000
#define TENS  9100

#define TEXT   10000
#define OUTPUT 16384

#define STACK  30000

static short nand(unsigned short r1,unsigned short r2) {
 
   return ~(r1&r2);
   
}

static void shift_right() {
   
//   printf("Shifting %04x by %04x\n",r1,r3);
   
//	#================================
//	# shift_right
//	#================================
//	# r7-2 = value to shift
//	# r7-3 = amount to divide by
//	#         (power of 2 only)
//	# r7-1 = return value
//shift_right:
        r[7]=r[7]+16;    // addi 	7,7,16		    # move stack
        mem[r[7]+6]=r[6];// sw  	6,7,6		    # back up return reg
        mem[r[7]+5]=r[5];// sw	5,7,5			    # back up r5
        mem[r[7]+4]=r[4];// sw	4,7,4			    # back up r4
        mem[r[7]+3]=r[3];// sw	3,7,3			    # back up r3
        mem[r[7]+2]=r[2];// sw	2,7,2			    # back up r2
        mem[r[7]+1]=r[1];// sw	1,7,1			    # back up r1
        
        r[5]=16;         // addi 5,0,16			    # 16-bits
        r[4]=0;          // add	4,0,0			    # clear output
        r[2]=1;        // addi	2,0,1		    # adder
        r[3]=mem[r[7]-3];

shift_loop:
        r[1]=mem[r[7]-2];   // lw 	1,7,-2
        r[6]=nand(r[1],r[3]);//	nand	6,1,3
        r[6]=nand(r[6],r[6]);//nand	6,6,6
        if (r[6]==0) 
           goto no_add;      //beq	6,0,no_add
        r[4]=r[4]+r[2];      //add	4,4,2
no_add:
        r[3]=r[3]+r[3];      //add	3,3,3
        r[2]=r[2]+r[2];  //add	2,2,2
        r[5]=r[5]-1;         //addi	5,5,-1
        if (r[5]==0) 
           goto done_shift;  //beq	5,0,done_shift
        if (0==0) 
           goto shift_loop;  //	beq	0,0,shift_loop

done_shift:
        mem[r[7]-1]=r[4];// sw   4,7,-16                   # store result
   
        r[6]=mem[r[7]+6]; //	lw 	6,7,6		    # restore link reg
        r[5]=mem[r[7]+5]; //	lw	5,7,5		    # restore r5
        r[4]=mem[r[7]+4]; //	lw	4,7,4		    # restore r4
        r[3]=mem[r[7]+3]; //	lw	3,7,3		    # restore r3
        r[2]=mem[r[7]+2]; //	lw	2,7,2		    # restore r2
        r[1]=mem[r[7]+1]; //	lw	1,7,1		    # restore r1
        r[7]=r[7]-16;     //	addi 	7,7,-16		    # restore stack	
//	jalr	0,6  		    # return         
   

   return;
}

static char hello[]="Hello World!\n";

unsigned char logo[284]=
{ 255, 27, 91, 48, 59, 49, 59, 51,
   55,159, 59, 52, 55,109, 35,204,
  247,192,  7, 51,141, 48,200, 27,
   27, 91,196,  7,203, 31, 28, 12,
   59, 15, 52, 48,109, 10,192,247,
    1, 96, 26, 56, 44,156, 31, 27,
   91, 51, 49,109,204,  4, 65,172,
   13, 36,  2, 28, 16, 79, 13, 32,
   16, 65,147,152,131, 52, 28, 52,
  204, 16, 16, 12, 36,111, 57,236,
  167, 28,  8, 51, 22, 20,137, 85,
   44, 96,  0, 43, 97,214,113,226,
  200,203,  8,212,  9,211, 16, 43,
   89,245,209,  0,128, 17,210, 24,
   13, 40, 28, 20, 13, 44, 28, 28,
  240, 74, 26, 91,  0, 13, 80, 95,
  101,135,101, 43, 85,245,205,205,
   40,205, 20,137, 65,  0, 29,135,
   66, 75,114, 83, 28,120, 15, 98,
  135,109, 85, 88,247,193,  0,232,
   43,244,151, 73,120, 61,176, 27,
   95,151,176, 18, 43,171,202, 16,
  223, 22, 26,245, 90,245,217, 63,
   51, 27, 86,146, 91,176,  2,  0,
   12, 29,211,200,172, 57, 23,102,
   50,246,110,109,236, 68, 96, 94,
    8,175, 10,166,105, 20,  1, 48,
   51, 11,222, 31, 49, 15,211,188,
    0,175, 79, 25, 86,170, 69, 82,
  219, 40, 82, 70,127,  8, 83,219,
   35,  0,169, 85,170, 53, 24, 33,
   18,104,145, 42,200, 34,178,104,
  112, 45,  0,198, 80,178,121,145,
   74,112, 49,248, 81,243, 40,221,
   23,255, 23,  8,  2, 54,  3, 36,
  229, 66, 10, 0
};




void shift_left() {
   r[7]=r[7]+16;    // addi 	7,7,16		    # move stack   
   mem[r[7]+2]=r[2];// sw	2,7,2		    # back up r2   
   r[1]=mem[r[7]-2];// lw       1,7,-2
   r[2]=mem[r[7]-3];// lw       1,7,-3
left_loop:      
   r[1]=r[1]+r[1];            // add  1,1,1
   r[2]--;                    // addi 2,2,-1
   if (r[2]==0) goto done;    // beq 2,0,done
   if(0==0) goto left_loop;   // beq 0,0,left_loop
done:
   mem[r[7]-1]=r[1]; // sw      1,7,-1
   r[2]=mem[r[7]+2]; //	lw	2,7,2		    # restore r2
   r[7]=r[7]-16;     //	addi 	7,7,-16		    # restore stack
   return;
   
}

//	#================================
//	# Read Byte
//	#================================
//	# r5 points to byte to read
//	# r4 stores odd/even info
//	# r7-1 stores result

void read_byte() {
   
//read_byte:
        r[7]=r[7]+16;    // addi 	7,7,16		    # move stack
        mem[r[7]+6]=r[6];// sw  	6,7,6		    # back up return reg
        mem[r[7]+3]=r[3];// sw	3,7,3			    # back up r3
        mem[r[7]+2]=r[2];// sw	2,7,2			    # back up r2
        mem[r[7]+1]=r[1];// sw	1,7,1			    # back up r1

        r[1]=mem[r[5]+0];       // lw	1,5,0			# load a word from logo
        if (r[4]==0) 
           goto even;           // beq	4,0,even   
        r[2]=0x00ff;            // movi	2,0x00ff   # mask to get low byte
        r[3]=nand(r[1],r[2]);   // nand	3,1,2
        r[3]=nand(r[3],r[3]);   // nand	3,3,3
        r[4]=0;                 // add  4,0,0  # make even
        r[5]=r[5]+1;            // addi 5,5,1  # increment r5
        if (0==0) 
           goto done_byte;      // beq	0,0,done_byte
		
even:	
        mem[r[7]+14]=r[1];      // sw   1,7,14
        r[1]=0x100;             // lui	1,0x100			# shift right by 8	
        mem[r[7]+13]=r[1];      // sw   1,7,13
        r[1]=0xcafe;
        r[6]=0xbabe;
        shift_right();          // movi 1,shift_right
                                // jalr 6,1
        r[3]=mem[r[7]+15];      // lw   3,7,15
        r[4]=1;                 // addi 4,0,1 # make odd
done_byte:

        mem[r[7]-1]=r[3]; //    sw      3,7,-1
   
        r[6]=mem[r[7]+6]; //	lw 	6,7,6		    # restore link reg
        r[3]=mem[r[7]+3]; //	lw	3,7,3		    # restore r3
        r[2]=mem[r[7]+2]; //	lw	2,7,2		    # restore r2
        r[1]=mem[r[7]+1]; //	lw	1,7,1		    # restore r1
        r[7]=r[7]-16;     //	addi 	7,7,-16		    # restore stack

//	jalr	0,6	
        return;
}



/* address in r5, which_byte in r4, value in r3 */
static void write_byte() {
   
   r[7]=r[7]+16;      // addi 	7,7,16		    # move stack
   mem[r[7]+6]=r[6];  // sw  	6,7,6		    # back up return reg
   mem[r[7]+3]=r[3];  // sw	3,7,3			    # back up r3
   mem[r[7]+2]=r[2];  // sw	2,7,2			    # back up r2
   mem[r[7]+1]=r[1];  // sw	1,7,1			    # back up r1
   
   r[1]=mem[r[5]+0];  // lw     1,5,0
   
   if (r[4]==0) 
      goto even;      // beq	4,0,even   
 
   r[2]=0xff00;         // lui 2,0xff00
   r[1]=nand(r[1],r[2]);// nand 1,1,2
   r[1]=nand(r[1],r[1]);// nand 1,1,1
   r[1]=r[1]+r[3];      // add  1,1,3
   mem[r[5]+0]=r[1];    // sw   1,5,0   
   r[4]=0;              // add  4,0,0         # make even
   r[5]=r[5]+1;         // addi 5,5,1         # increment pointer
   if (0==0) 
      goto done_byte;   // beq	0,0,done_byte
		
even:	
   r[1]=0x00ff;         // movi 1,0x00ff
   r[2]=nand(r[1],r[2]);// nand 2,1,2
   r[2]=nand(r[2],r[2]);// nand 2,2,2         # erase top half
   r[1]=8;              // addi 1,0,8         # shift amount
   mem[r[7]+13]=r[1];   // sw   1,7,13
   mem[r[7]+14]=r[3];   // sw   3,7,14
   r[1]=0xdead;         // movi 1,shift_left
   r[6]=0xbeef;         // jalr 6,1
   shift_left();
   r[3]=mem[r[7]+15];   // lw   3,7,15
   r[2]=r[2]+r[3];      // add  2,2,3         # put new value in
   mem[r[5]+0]=r[2];    // sw   2,5,0   
   r[4]=1;              // addi 4,0,1         # make odd
   
done_byte:
   
        r[6]=mem[r[7]+6]; //	lw 	6,7,6		    # restore link reg
        r[3]=mem[r[7]+3]; //	lw	3,7,3		    # restore r3
        r[2]=mem[r[7]+2]; //	lw	2,7,2		    # restore r2
        r[1]=mem[r[7]+1]; //	lw	1,7,1		    # restore r1
        r[7]=r[7]-16;     //	addi 	7,7,-16		    # restore stack
   
}

static int write_stdout(short fd, short pointer) {
   int result=0,i,tmp;
   char buffer[BUFSIZ];
   
   int length=0;
   
   i=0;
   while(1) {
      tmp=(mem[pointer+i]>>8)&0xff;
      if (tmp==0) break;
      length++;
      tmp=(mem[pointer+i])&0xff;
      if (tmp==0) break;      
      length++;      
      i++;
   }

   for(i=0;i<(length+1)/2;i++) {
      buffer[i*2]=(mem[pointer+i]>>8)&0xff;
      buffer[i*2+1]=(mem[pointer+i])&0xff;
   }
   result=write(fd,buffer,length);
   
   return result;
}
   
short powers_of_ten[]={0,1,10,100,1000,10000};

static void do_divide() {

   int i;

   for(i=0;i<6;i++) {
      mem[TENS+i]=powers_of_ten[i];
   }
   
   r[7]=r[7]+16;

    mem[r[7]+5]=r[5];               // sw 5,7,5
    mem[r[7]+4]=r[4];               // sw 4,7,4

    r[1]=1;                         // addi 1,0,1
    mem[r[7]+8]=r[1];               // sw 1,7,8     # skip zeros
   
   r[5]=TENS;                       // movi 5,tens
   r[5]+=5;                         // addi 5,5,5
   
div_loop:   
   r[6]=mem[r[5]+0];                // lw  6,5,0
   if (r[6]==0) goto done_div;      // beq 6,0,done_div   
   r[3]=0;                          // add 3,0,0  # count
sub_loop:
   r[1]=r[6];                       // add 1,6,0
   r[1]=nand(r[1],r[1]);            // nand 1,1,1
   r[1]=r[1]+1;                     // addi 1,1,1
   r[1]=r[1]+r[2];                  // add 1,1,2
   r[4]=0x8000;                     // lui 4,0x8000
   r[1]=nand(r[1],r[4]);            // nand 1,1,4
   r[1]=nand(r[1],r[1]);            // nand 1,1,1
   if (r[1]==0) goto not_less;      // beq  1,0,not_less
   if (0==0) goto done_sub;         // beq  0,0,done_sub
not_less:   
   r[3]=r[3]+1;                     // addi 3,3,1 # increment count
   r[1]=mem[r[5]+0];                // lw   1,5,0
   r[6]=r[6]+r[1];                  // add  6,6,1
   goto sub_loop;                   // beq  0,0,sub_loop
done_sub:
   r[1]=r[6];                       // add 1,0,6
   r[1]=nand(r[1],r[1]);            // nand 1,1,1
   r[1]=r[1]+1;                     // addi 1,1,1
   r[2]=r[2]+r[1];                  // add 2,2,1
   r[1]=mem[r[5]+0];                // lw  1,5,0
   r[2]=r[2]+r[1];                  // add 2,2,1

   if (r[3]==0) goto we_have_a_zero;// beq 3,0,we_have_a_zero
   goto write_char;                 // beq 0,0,write_char
we_have_a_zero:
   r[1]=r[1]-1;                     // addi 1,1,-1
   if (r[1]==0) goto write_char;    // beq  1,0,write_char
   r[1]=mem[r[7]+8];                // lw   1,7,8
   if (r[1]==0) goto write_char;    // beq  1,0,write_char
   goto skip_write;                 // beq  0,0,skip_write
	 
write_char:	 
      r[3]+=0x30;                   // addi 3,3,0x30            
      mem[r[7]+9]=r[5];             // sw   5,7,9
      r[5]=mem[r[7]+5];             // lw   5,7,5
      r[4]=mem[r[7]+4];             // lw   4,7,4
      r[1]=0x1ee7;                  // movi 1,write_byte
      r[6]=0x0b0e;                  //
      write_byte();                 // jalr 6,1
      mem[r[7]+5]=r[5];             // sw   5,7,5
      mem[r[7]+4]=r[4];             // sw   4,7,4
      r[5]=mem[r[7]+9];             // lw   5,7,9
      mem[r[7]+8]=0;                // sw   0,7,8

   
skip_write:   

   r[5]=r[5]-1;                     // addi 5,5,-1
   goto div_loop;                   // beq  0,0,div_loop
   
done_div:   
   r[3]=0;                          // add  3,0,0
   r[5]=mem[r[7]+5];                // lw   5,7,5
   r[4]=mem[r[7]+4];                // lw   4,7,4
   r[1]=0xbabe;                     // movi 1,write_byte
   r[6]=0x7734;                     // 
   write_byte();                    // jalr 6,1
   
   r[7]=r[7]-16;   
}
   
int main(int argc, char **argv) {
   
   int i;

   for(i=0;i<65536;i++) mem[i]=0;
   for(i=0;i<LOGO_SIZE/2;i++) mem[LOGO+i]=(logo[i*2]<<8)+logo[(i*2)+1];
   for(i=0;i<(strlen(hello)+1)/2;i++) {
      mem[HELLO+i]=(hello[i*2]<<8)+hello[(i*2)+1];
   }
   r[0]=0;
 
   
//_start:

   r[7]=STACK;                // movi 7,stack   
   r[1]=LOGO;                 // movi 1,logo
   mem[r[7]+1]=r[1];          // sw   1,7,1  # logo_ptr
   mem[r[7]+2]=0;             // sw   0,7,2  # logo_byte

   r[1]=OUTPUT;               // movi 1,output
   mem[r[7]+3]=r[1];          // sw   1,7,3  # output_byte
   mem[r[7]+4]=0;             // sw   0,7,4  # output_byte

   r[1]=(1024-64)/2;          // movi 1,     # N-F
   mem[r[7]+5]=r[1];          // sw   1,7,5
   mem[r[7]+6]=0;             // sw   0,7,6
   
decompression_loop:
   
   r[5]=mem[r[7]+1];          // lw   5,7,1      # output_ptr
   r[4]=mem[r[7]+2];          // lw   4,7,2      # output_byte
   r[1]=0xbabe;               // movi 1,read_byte
   r[6]=0xdead;               // jalr 6,1
   read_byte();
   r[1]=mem[r[7]+15];         // lw   1,7,15
   mem[r[7]+7]=r[1];          // sw   1,7,7      # store command byte
   
   mem[r[7]+1]=r[5];          // sw   5,7,1      # store output_ptr
   mem[r[7]+2]=r[4];          // sw   4,7,2      # store output_byte

   r[1]=0x1;                  // addi 1,0,1      # mask 
   mem[r[7]+8]=r[1];          // sw   1,7,8
   
test_flags:
   
   r[1]=mem[r[7]+1];          // lw  1,7,1       # load output_ptr
   r[2]=(LOGO+(LOGO_SIZE/2)); // movi 2,logo_end # compare with end
   if (r[1]==r[2]) 
      goto done_logo;         // beq 1,2,done_logo
     
   r[1]=mem[r[7]+7];          // lw 1,7,7        # load back command word
   r[2]=mem[r[7]+8];          // lw 2,7,8        # load in mask
   r[1]=nand(r[1],r[2]);      // nand 1,1,2      # mask
   r[1]=nand(r[1],r[1]);      // nand 1,1,1
   r[2]=r[2]+r[2];            // add  2,2,2      # shift mask left
   mem[r[7]+8]=r[2];          // sw   2,7,8      # store out mask 
   
   if (r[1]==0)               // beq  1,0,offset_length
      goto offset_length;
   if (0==0) 
      goto discrete_char;     // beq 0,0,discrete_char
   
offset_length:
   r[5]=mem[r[7]+1];          // lw   5,7,1      # load logo_ptr
   r[4]=mem[r[7]+2];          // lw   4,7,2      # load logo_byte
   r[1]=0xdead;               // movi 1,read_byte
   r[6]=0xbeef;               // jalr 6,1
   read_byte();
   
   r[2]=mem[r[7]+15];         // lw   2,7,15     # get result in r2
   r[1]=0xdead;               // movi 1,read_byte  #FIXME needed?
   r[6]=0xbeef;               // jalr 6,1   
   read_byte();
   
   r[1]=mem[r[7]+15];         // lw   1,7,15     # get result in r1
   mem[r[7]+1]=r[5];          // sw   5,7,1      # update logo_ptr
   mem[r[7]+2]=r[4];          // sw   4,7,2      # update logo_byte

   mem[r[7]+14]=r[1];         // sw   1,7,14     # we want to shift
   r[1]=8;                    // addi 1,0,8      # left by 8
   mem[r[7]+13]=r[1];         // sw   1,7,13
   r[1]=0xdead;               // movi 1,shift_left
   r[6]=0xbeef;
   shift_left();              // jalr 6,1
   r[1]=mem[r[7]+15];         // lw   1,7,15     # load result

   r[1]=r[1]+r[2];            // add  1,1,2      # merge into 16-bit value
   mem[r[7]+9]=r[1];          // sw   1,7,9      # store as position

   mem[r[7]+14]=r[1];         // sw   1,7,14     # value to shift
   r[1]=0x400;                // lui  1,0x400    # amount to shift (P_BITS)
   mem[r[7]+13]=r[1];         // sw   1,7,13
   r[1]=0xb00b;               // movi 1,shift_right
   r[6]=0xbabe;               // jalr 6,1
   shift_right();
   r[1]=mem[r[7]+15];         // lw   1,7,15
   r[1]=r[1]+3;               // addi 1,1,3      # add in THRESHOLD+1
   mem[r[7]+10]=r[1];         // sw   1,7,10     # store as count
   
output_loop:

   r[1]=0x3ff;                // movi 1,0x3ff    # mask 
   r[2]=mem[r[7]+9];          // lw   2,7,9      # load in position
   r[2]=nand(r[1],r[2]);      // nand 2,1,2
   r[2]=nand(r[2],r[2]);      // nand 2,2,2
   mem[r[7]+9]=r[2];          // sw   2,7,9      # store back masked pos
   
   mem[r[7]+14]=r[2];         // sw   2,7,14     # want to shift this
   r[1]=2;                    // addi 1,0,2      # right by 1
   mem[r[7]+13]=r[1];         // sw   1,7,13     
   r[1]=0x1978;               // movi 1,shift_right
   r[6]=0x1980;               // jalr 6,1
   shift_right();
   r[1]=mem[r[7]+15];         // lw   1,7,15     # load rsult
   r[5]=TEXT;                 // movi 5,text     # point to text_buf
   r[5]=r[5]+r[1];            // add  5,5,1      # add in position
   
   r[1]=1;                    // addi 1,0,1      # mask for byte hi/lo
   r[4]=nand(r[2],r[1]);      // nand 4,2,1
   r[4]=nand(r[4],r[4]);      // nand 4,4,4   
   
   r[1]=0xdead;               // movi 1,read_byte
   r[6]=0xcafe;               // jalr 6,1
   read_byte();
   
   r[3]=mem[r[7]+15];         // lw   3,7,15    # byte to write
   
   r[2]=r[2]+1;               // addi 2,2,1     # increment position
   mem[r[7]+9]=r[2];          // sw   2,7,9     # store out to mem
   
store_byte:

   r[5]=mem[r[7]+3];          // lw   5,7,3     # load output_ptr
   r[4]=mem[r[7]+4];          // lw   4,7,4     # load output_byte
   r[1]=0x2008;               // movi 1,write_byte
   r[2]=0x3000;               // jalr 6,1
   write_byte();
   mem[r[7]+4]=r[4];          // sw   4,7,4     # save output_byte
   mem[r[7]+3]=r[5];          // sw   5,7,3     # save output_ptr
   
   r[2]=TEXT;                 // movi 2,text    # load text
   r[5]=mem[r[7]+5];          // lw   5,7,5     # load r_ptr
   r[5]=r[2]+r[5];            // add  5,2,5     # text+r_ptr
   r[4]=mem[r[7]+6];          // lw   4,7,6     # load r_byte
   r[1]=0x8008;               // movi 1,write_byte
   r[6]=0x8086;               // jalr 6,1
   write_byte();
   mem[r[7]+6]=r[4];          // sw   4,7,6    # store r_byte
   r[1]=nand(r[2],r[2]);      // nand 1,2,2    # flip bits in TEXT
   r[1]=r[1]+1;               // addi 1,1,1    # add one (2s complement)
   r[1]=r[5]+r[1];            // add  1,5,1    # we effectively subtracted
   
   r[2]=511;                  // movi 2,511    # mask with (1024>>2)-1
   r[1]=nand(r[1],r[2]);      // nand 1,1,2
   r[1]=nand(r[1],r[1]);      // nand 1,1,1
   mem[r[7]+5]=r[1];          // sw   1,7,5    # store back r_ptr

   r[1]=mem[r[7]+10];         // lw   1,7,10   # load in count
   r[1]=r[1]-1;               // addi 1,1,-1   # decrement
   mem[r[7]+10]=r[1];         // sw   1,7,10   # save back count
   
   if (r[1]==0)               // beq  1,0,done_count
      goto done_count;
   if (0==0)                  // beq  0,0,output_loop
      goto output_loop;   
done_count:  
   
   r[1]=mem[r[7]+8];          // lw 1,7,8        # load in mask
   r[2]=0x100;                // lui 2,0x100     # see if we are done
   if (r[1]==r[2]) 
      goto decompression_loop; // beq 1,2,decompression_loop
   
   goto test_flags;   // beq  0,0,test_flags

discrete_char:

   r[5]=mem[r[7]+1];  // lw 5,7,1   # load in logo_ptr
   r[4]=mem[r[7]+2];  // lw 4,7,2   # load in logo_byte
   r[1]=0x0feb;       // movi 1,read_byte
   r[6]=0x1378;       // jalr 6,1
   read_byte();
   r[3]=mem[r[7]+15]; // lw 3,7,15  # load result into r3
   mem[r[7]+1]=r[5];  // sw 5,7,1   # store logo_ptr
   mem[r[7]+2]=r[4];  // sw 4,7,2   # store logo_byte
   r[1]=1;            // addi 1,0,1 # count
   mem[r[7]+10]=r[1]; // sw   1,7,10 # store count
   goto store_byte;   // beq 0,0,store_byte
   
done_logo:
   
   printf("DONE LOGO!\n");
   write_stdout(1,OUTPUT);
   write_stdout(1,HELLO);
   
//	#================================
//	# Exit
//	#================================
//exit:	
//        addi 	1,0,SYSCALL_EXIT	    # Put syscall in R1
//	add	2,0,0		    	    # Exit with a 0
//	sys 	0			    # syscall	
//	halt				    # just in case

   r[2]=16384;
   printf("Attempting to divide %d\n",r[2]);
   r[5]=OUTPUT;
   r[4]=0;
   do_divide();
   write_stdout(1,OUTPUT);
   printf("\n");
   
   r[2]=256;
   printf("Attempting to divide %d\n",r[2]);
   r[5]=OUTPUT;
   r[4]=0;   
   do_divide();
   write_stdout(1,OUTPUT);
   printf("\n");
   
   r[2]=100;
   printf("Attempting to divide %d\n",r[2]);
   r[5]=OUTPUT;
   r[4]=0;   
   do_divide();
   write_stdout(1,OUTPUT);
   printf("\n");   
   
   r[2]=0;
   printf("Attempting to divide %d\n",r[2]);
   r[5]=OUTPUT;
   r[4]=0;   
   do_divide();
   write_stdout(1,OUTPUT);
   printf("\n");
   
   return 0;
}

	
